# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write tobthe Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# modified by longjun
# 统一route风格
# match 'path', :to => 'controller#action'
# 如果 path = controller#action 则 match 'path'
# Example:
# match 'welcome/course', :to => 'welcome#course' 变成
# match 'welcome/cource'
# 所有的 act: :act 变成  :act => :act
# Example: :via =>  :get ====> :via => :get

RedmineApp::Application.routes.draw do
  mount Mobile::API => '/api'

  # Enable Grack support
  # mount Trustie::Grack.new, at: '/', constraints: lambda { |request| /[-\/\w\.]+\.git\//.match(request.path_info) }, via: [:get, :post]

  constraints(Subdomain.new) do
    get '/', to: 'organizations#show'
  end

  constraints(Subdomain.new(sub: true)) do
    get '/:sub_dir_name', to: 'fake#fake'
  end

  resources :shield_wechat_messages do
    collection do
      delete 'show_messages'
    end
  end
  resources :shield_activities do
    collection do
      delete 'show_acts'
    end
  end
  resources :organizations do
    resource :files do
      member do

      end
      collection do

      end
    end
    resources :org_document_comments do
      member do

      end
      collection do

      end
    end
    member do
      get 'edit'
      get 'setting'#, :action => 'settings', :as => 'settings'
      get 'clear_org_avatar_temp'
      put 'set_homepage'
      put 'cancel_homepage'
      get 'members'
      get 'more_org_projects'
      get 'more_org_courses'
      get 'search_courses'
      get 'teachers'
      post 'join_course_menu'
      post 'join_courses'
      get 'search_projects'
      post 'join_project_menu'
      post 'join_projects'
      post 'logout'
      post 'apply_subdomain'
      get  'org_resources_subfield'
      get '/:sub_dir_name', :to => 'org_subfields#show', :as => 'show_org_subfield'
    end
    collection do
      get 'check_uniq'
      get 'check_uniq_domain'
      get 'autocomplete_search'
      post 'hide_org_subfield'
      post 'show_org_subfield'
      post 'set_excellent_teacher'
      post 'reset_excellent_teacher'
      post 'agree_apply_subdomain'
    end
  end




  resources :org_member do
    member do

    end
    collection do
      get 'org_member_autocomplete'
    end
  end

  resources :org_subfields do
    resources :files, :only => [:index, :new, :create] do
      collection do
        match "getattachtype", :via =>  [:get, :post]
        match "search_files_in_subfield",:via => [:post,:get]
        match "searchone4reload",:via => [:post,:get]
        match "search_org_subfield_tag_attachment", :via => [:post,:get]
        match "subfield_upload_file", :via => :post
      end
      member do
        match "quote_resource_show_org_subfield", :via => [:get]
      end
    end

    resources :sub_domains, :only => [:index, :new, :create, :show, :update, :destroy] do
      resources :sub_document_comments, :only => [:index, :new, :create, :show, :update, :destroy, :edit] do
        member do
          post 'add_reply'
          get 'quote'
          post 'reply'
          post 'add_reply_in_doc'
          delete 'delete_reply'
          match 'edit'
        end
        collection do
        end
      end

      collection do
      end
      member do
        match 'domain_update_sub_dir', :via => [:put]
        match 'domain_update_priority', :via => [:put]
        match 'domain_update_status', :via => [:post]
        post 'hide_sub_domain'
        post 'show_sub_domain'
      end
    end

    member do
      match 'update_sub_dir', :via => [:put]
      match 'update_priority', :via => [:put]
      match 'update_status', :via => [:post]
    end
    resource :boards
  end

  resources :org_document_comments do
    member do
      post 'add_reply'
      get 'quote'
      post 'reply'
      post 'add_reply_in_doc'
      delete 'delete_reply'
    end
    collection do

    end
  end

  resources :org_projects do
    member do

    end
    collection do

    end
  end

  resources :org_courses do
    member do

    end
    collection do

    end
  end
  #match '/organizations/:organization_id/org_document_comments/new', :to => 'org_document_comments#new', :as => 'new_org_documents', :via => [:get, :post]
  #match '/organizations/:organization_id/org_document_comments/create', :to => 'org_document_comments#create', :as => 'create_org_documents', :via => [:post]
  resources :homework_users
  resources :no_uses
  delete 'no_uses', :to => 'no_uses#delete'
  match 'site_search', :to => 'users#site_search', :as => 'site_search', :via => [:get, :post, :put]
  resources :apply_project_masters
  delete 'apply_project_masters', :to => 'apply_project_masters#delete'

  # resources :organization, :except => [:show] do
  #
  # end

  resources :school, :except => [:show] do
    collection do

    end

    member do
      get 'upload_logo'
      post 'upload'
    end
  end

  resources :homework_attach do
    collection do
      get 'get_homework_member_list'
      match 'addjours', :via => [:get, :post]
      match 'add_jour_reply', :via => [:get,:post]
      match 'destroy_jour', :via => [:get,:post]
      match 'comprehensive_evaluation_jour', :via => [:get,:post]
      get 'get_not_batch_homework'
      get 'get_batch_homeworks'
      get 'get_homeworks'
      get 'get_homework_jours'
      get 'get_student_batch_homework'
      get 'get_my_homework'
    end
    member do
      match 'add_homework_users', :via => [:get,:post]
      match 'destory_homework_users', :via => [:get,:post]
      get 'praise_homework'
    end
  end

  resources :poll do
    member do
      get 'statistics_result'
      post 'commit_answer'
      post 'create_poll_question'
      post 'commit_poll'
      get 'publish_poll'
      get 'republish_poll'
      get 'poll_result'
      get 'close_poll'
      get 'export_poll'
      get 'import_poll'

    end
    collection do
      delete 'delete_poll_question'
      post 'update_poll_question'
      get 'other_poll'
      post 'import_other_poll'
    end
  end

  #show、index、new、create、edit、update、destroy路由自动生成
  resources :exercise do
    member do #生成路径为 /exercise/:id/方法名
      get 'statistics_result'
      get 'student_exercise_list'
      get 'export_exercise'
      get 'publish_exercise'
      get 'republish_exercise'
      get 'show_student_result'
      post 'create_exercise_question'
      post 'commit_answer'
      post 'commit_exercise'
    end

    collection do #生成路径为 /exercise/方法名
      delete 'delete_exercise_question'
      post 'update_exercise_question'
    end
  end

  resources :homework_common, :except => [:show]do
    member do
      get 'start_anonymous_comment'
      get 'stop_anonymous_comment'
      get 'alert_anonymous_comment'
      get 'alert_forbidden_anonymous_comment'
      get 'alert_open_student_works'
      get 'open_student_works'
      get 'start_evaluation_set'
      get 'score_rule_set'
      post 'set_evaluation_attr'
    end

    collection do
      post 'next_step'
      post 'programing_test'
    end
  end

  resources :student_work do
    member do
      post 'add_score'
      post 'revise_attachment'
      get 'retry_work'
      get 'add_comments_to_work'
      get 'praise_student_work'
      get 'forbidden_anonymous_comment'
    end
    collection do
      post 'add_score_reply'
      post 'student_work_project'
      get 'new_student_work_project'
      get 'search_user_projects'
      get 'search_course_students'
      get 'cancel_relate_project'
      get 'delete_work'
      get 'destroy_score_reply'
      get 'student_work_absence_penalty'
      get 'absence_penalty_list'
      get 'evaluation_list'
      # post 'set_program_score'
      post 'program_test_ex'
      post 'code_repeattest'
      post 'last_codecomparetime'
      post 'set_score_rule'
      get 'work_canrepeat'
    end
  end

  resources :contest_notification

  resources :open_source_projects do
    collection do
      match 'search', :via => [:get, :post]
      match 'remove_condition', :via => [:get, :post]
      match 'allbug', :via => [:get, :post]
    end
    resources :relative_memos
    member do
      match 'master_apply', :via => [:get, :post]
      match 'accept_master_apply', :via => [:get, :post]
      match 'refuse_master_apply', :via => [:get, :post]
      match 'showmemo', :via =>  [:get, :post]
      match 'showbug', :via =>  [:get, :post]
    end
  end


  mount SeemsRateable::Engine => '/rateable', :as => :rateable

  namespace :zipdown do
    match 'assort'
    match 'download_user_homework', :as => :download_user_homework
    match 'download'
  end
  namespace :test do
    match 'courselist'
    match 'zip'
    match 'mailer'
    match 'view_office'
  end
  ##new added by linchun #以发布应用的形式参与竞赛
  resources :softapplications do

    collection do
      match 'new_message',     :via => :get
      match 'search', :via => [:get, :post]
    end
    member do
      match 'create_message' , :via =>  :post
    end
  end

  ## new added by linchun #新竞赛相关
  resources :contests, only: [:index] do
    resources :contestnotifications do
      # get 'preview', on: :collection
      resources :notificationcomments
    end

    collection do
      match 'new_contest'        , :via =>  :get
      match 'join_in_contest'    , :via =>  :post
      match 'unjoin_in_contest'  , :via =>  :delete
      match 'create_contest'     , :via =>  :post
      match 'new_join'           , :via =>  :post
      match 'new'                , :via =>  :post
    end
    member do
      delete 'destroy_contest'
      match 'add_softapplication'
      match 'update_contest'             , :via =>  [:put]
      match 'show_contest'               , :via =>  [:get, :post]
      match 'show_project'               , :via =>  :get
      match 'show_softapplication'       , :via =>  :get
      match 'show_attendingcontest'      , :via =>  :get
      #match 'show_notification'          , :via =>  :get
      match 'show_participator'          , :via =>  :get
      match 'set_reward_project'         , :via =>  [:get, :post]
      match 'set_reward_softapplication' , :via =>  [:get, :post]
      match 'add'                        , :via =>  [:get, :post]
      match 'add_softapplication'        , :via =>  [:get, :post]
      match 'create'                     , :via =>  :post
      match 'settings'                   , :via =>  [:get, :post]
      match 'show_contest_user'
      get 'watcherlist', :action=> 'watcherlist'
    end
  end

  match '/news/preview', :to => 'previews#news', :as => 'preview_news', :via => [:get, :post, :put]
  match '/issues/preview/new/:project_id', :to => 'previews#issue', :as => 'preview_new_issue', :via => [:get, :post, :put]
  match '/issues/preview/edit/:id', :to => 'previews#issue', :as => 'preview_edit_issue', :via => [:get, :post, :put]
  match '/issues/preview', :to => 'previews#issue', :as => 'preview_issue', :via => [:get, :post, :put]
  match '/contestnotifications/preview', :to => 'previews#contestnotification', :as => 'preview_contestnotifications', :via => [:get, :post, :put]

  resources :stores do
    collection do
      match 'search', :via =>  [:get, :post]
      get 'lost_file'
    end
  end

  resources :forums do
    collection do
      match 'search_forum', :via => [:get, :post]
      match 'check_forum_name',:via => [:get]
    end
    member do
      post 'create_memo'
      post 'create_feedback'
      match 'search_memo', :via => [:get, :post]
      match 'delete_forum_tag',:via =>[:get]
      match 'add_forum_tag',:via=>[:get]
    end
    resources :memos do
      collection do
        get "quote"
      end
    end
  end


  resources :shares

  #added by william
  get "tags/index"

  get "tags/show"

  get "praise_tread/praise_plus"
  get "praise_tread/praise_minus"

  get "praise_tread/tread_plus"
  #end

  root :to => 'welcome#index', :as => 'home'
  # added by longjun
  match 'welcome/contest',  :via => :get
  # end longjun

  #added by nie
  match '/projects/search',  :via => [:get, :post]
  match '/users/search', :via => [:get, :post]
  #end

  # 消息相关路由
  resources :system_messages do
    collection do
      post 'create', :as => 'system_messages'
      get 'index', :as => 'index'
    end
  end
  # match 'system_messages/index', to: 'system_messages#index', :via => :get, :as => 'system_messages'

  match 'account/heartbeat', to: 'account#heartbeat', :via => :get
  match 'login', :to => 'account#login', :as => 'signin', :via => [:get, :post]
  match 'logout', :to => 'account#logout', :as => 'signout', :via => [:get, :post]
  match 'agreement',:to => 'account#agreement',:as => 'agreement',:via=>[:get]
  match 'about_us',:to=>'account#about_us',:as=>'about_us',:via=>[:get]
  match 'account/register', :via => [:get, :post], :as => 'register'
  match 'account/lost_password',  :via => [:get, :post], :as => 'lost_password'
  match 'account/activate',  :via => :get
  match 'account/valid_ajax',  :via => :get
  match 'account/email_valid', :to => 'account#email_valid', :via => :get
  match 'account/resendmail', :to => 'account#resendmail', :via=> :get
  match 'projects/:id/wiki', :to => 'wikis#edit', :via => :post
  match 'projects/:id/wiki/destroy', :to => 'wikis#destroy', :via => [:get, :post]

  # boards
  match 'boards/:board_id/topics/new', :to => 'messages#new', :via => [:get, :post], :as => 'new_board_message'
  match 'boards/:id/join_to_org_subfields', :to => 'boards#join_to_org_subfields'
  get 'boards/:board_id/topics/:id', :to => 'messages#show', :as => 'board_message'
  match 'boards/:board_id/topics/quote/:id', :to => 'messages#quote', :via => [:get, :post]
  get 'boards/:board_id/topics/:id/edit', :to => 'messages#edit',:as=>'edit_board_message'

  post 'boards/:board_id/topics/preview', :to => 'messages#preview', :as => 'preview_board_message'
  post 'boards/:board_id/topics/:id/replies', :to => 'messages#reply'
  post 'boards/:board_id/topics/:id/edit', :to => 'messages#edit'
  post 'boards/:board_id/topics/:id/destroy', :to => 'messages#destroy',:as=>'delete_board_message'
  match 'messages/join_org_subfield', :to => 'messages#join_org_subfield'
  match 'messages/get_subfield_on_click_org', :to => 'messages#get_subfield_on_click_org'
  match 'messages/join_org_subfields', :to => 'messages#join_org_subfields'
  # boards end

  # Misc issue routes. TODO: move into resources
  match '/issues/auto_complete', :to => 'auto_completes#issues', :via => :get, :as => 'auto_complete_issues'
  match '/issues/context_menu', :to => 'context_menus#issues', :as => 'issues_context_menu', :via => [:get, :post]
  match '/issues/changes', :to => 'journals#index', :as => 'issue_changes', :via => :get
  match '/issues/:id/quoted', :to => 'journals#new', :id => /\d+/, :via => :post, :as => 'quoted_issue'

  match '/journals/diff/:id', :to => 'journals#diff', :id => /\d+/, :via => :get
  match '/journals/edit/:id', :to => 'journals#edit', :id => /\d+/, :via => [:get, :post]
  match '/journals/destroy/:id', :to => 'journals#destroy', :id => /\d+/, :via => [:get, :post]

  get '/projects/:project_id/issues/gantt', :to => 'gantts#show', :as => 'project_gantt'
  get '/issues/gantt', :to => 'gantts#show'

  get '/projects/:project_id/issues/calendar', :to => 'calendars#show', :as => 'project_calendar'
  get '/issues/calendar', :to => 'calendars#show'

  get 'projects/:id/issues/report', :to => 'reports#issue_report', :as => 'project_issues_report'
  get 'projects/:id/issues/report/:detail', :to => 'reports#issue_report_details', :as => 'project_issues_report_details'
  post '/users/:id/user_activities', :to => 'users#show', :as => "user_activities"
  match 'projects/:project_id/news/index', :to => 'news#index', :via => [:get, :post], :as => 'new_course_news'
  match 'projects/:project_id/news/new', :to => 'news#new', :via => [:get, :post]

  post '/courses/:id/course_activity', :to => 'courses#show', :as => 'course_activity'
  get '/boards/:id/boards_topic', :to =>'boards#show', :as => 'boards_topic'
  match 'courses/:course_id/news/index', :to => 'news#index', :via => [:get, :post], :as => 'new_course_news'
  match 'courses/:course_id/news/new', :to => 'news#new', :via => [:get, :post]

  scope ":username" do
    resources :posts
  end

  #added by young
  resources :users do
    collection do
      match "tag_saveEx" , :via =>  [:get, :post]
      post "user_new_homework"
      get  'new_user_commit_homework'
      get 'reply_to'
      get 'show_all_replies'
      post "user_commit_homework"
      post 'user_select_homework'
    end

    member do
      match 'user_projects_index', :to => 'users#user_projects_index', :via => :get
      match 'user_projects', :to => 'users#user_projects',  :via => :get
      match 'user_activities', :to => 'users#user_activities',  :via => :get, :as => "user_activities"
      # match 'user_newfeedback', :to => 'users#user_newfeedback',  :via => :get, :as => "user_newfeedback"
      match 'info', :to => 'users#info', :via => [:get , :post], :as => 'user_info'
      match 'user_watchlist', :to => 'users#user_watchlist',  :via => :get, :as => "user_watchlist" #add by huang
      match 'user_fanslist', :to => 'users#user_fanslist',  :via => :get, :as => "user_fanslist" #add by huang
      match 'user_courses', :to => 'users#user_courses', :via => :get
      match 'user_courses4show', :to => 'users#user_courses4show', :via => :get
      match 'user_projects4show', :to => 'users#user_projects4show', :via => :get
      match 'user_course_activities', :to => 'users#user_course_activities', :via => :get
      match 'user_project_activities', :to => 'users#user_project_activities', :via => :get
      match 'user_feedback4show', :to => 'users#user_feedback4show', :via => :get
      match 'user_visitorlist', :to => 'users#user_visitorlist', :via => :get
      match 'apply_for_homework', :to => 'users#apply_for_homework', :via => :post
      match 'apply_homework', :to => 'users#apply_homework', :via => :get
      match 'user_homeworks', :to => 'users#user_homeworks', :via => :get
      match 'student_homeworks', :to => 'users#student_homeworks', :via => :get
      get 'apply_resource'
      get 'user_import_homeworks'
      get 'user_search_homeworks'
      get 'choose_user_course'
      get 'user_import_resource'
      match 'watch_projects', :to => 'users#watch_projects', :via => :get
      #
      # added by bai
      match 'show_score', :to => 'users#show_score', :via => :get
      match 'topic_score_index', :to => 'users#topic_score_index', :via => [:get, :post]
      match 'project_score_index', :to => 'users#project_score_index', :via => :get
      match 'activity_score_index', :to => 'users#activity_score_index', :via => :get
      match 'influence_score_index', :to => 'users#influence_score_index', :via => :get
      match 'score_index', :to => 'users#score_index', :via => :get

      match 'show_new_score', :to => 'users#show_new_score', :via => :get
      match 'topic_new_score_index', :to => 'users#topic_new_score_index', :via => [:get, :post]
      match 'project_new_score_index', :to => 'users#project_new_score_index', :via => :get
      match 'activity_new_score_index', :to => 'users#activity_new_score_index', :via => :get
      match 'influence_new_score_index', :to => 'users#influence_new_score_index', :via => :get
      match 'score_new_index', :to => 'users#score_new_index', :via => :get
      match 'update_score', :to => 'users#update_score', :via => [:get,:post]

      match 'show_projects_score', :to => 'projects#show_projects_score', :via => [:get, :post]
      match 'issue_score_index', :to => 'projects#issue_score_index', :via => [:get, :post]
      match 'news_score_index', :to => 'projects#news_score_index', :via => [:get, :post]
      match 'file_score_index', :to => 'projects#file_score_index', :via => [:get, :post]
      match 'code_submit_score_index', :to => 'projects#code_submit_score_index', :via => [:get, :post]
      match 'projects_topic_score_index', :to => 'projects#projects_topic_score_index', :via => [:get, :post]
      match 'user_act_issue_assign_to', :to => 'users#user_act_issue_assign_to', :via => [:get, :post]

      #addby yk
      match 'user_courselist', :to => 'users#user_courselist',  :via => :get, :as => "user_courselist"
      match 'user_projectlist', :to => 'users#user_projectlist',  :via => :get, :as => "user_projectlist"

      get 'edit_brief_introduction'
      get "user_resource"
      get "import_resources"
      get "import_resources_search"
      post "import_into_container"
      get "resource_search"
      post "user_resource_create"
      post "user_resource_delete"
      get "search_user_course"
      post "send_homework_to_course"
      post "add_exist_file_to_course"
      post "add_exist_file_to_project"
      post 'add_exist_file_to_org'
      post 'share_news_to_course'
      post 'share_news_to_project'
      post 'share_news_to_org'
      post 'share_message_to_course'
      post 'share_message_to_project'
      post 'share_message_to_org'
      get 'resource_preview'
      get 'rename_resource'
      get 'search_user_project'
      get 'user_resource_type'
      get 'user_ref_resource_search'
      post 'import_resources_to_homework'
      get 'dealwith_apply_request'
      get 'dealwith_apply_homework'
      get 'deal_with_apply_resource'
      get 'store_selected_resource'
      get 'user_organizations'
      get 'search_user_orgs'
      get 'search_user_org' #for send resource
      get 'user_homework_type'
      get 'user_ref_homework_search'
      get 'show_homework_detail'
      post 'apply_for_homework'
      post 'apply_for_resource'
      # end
    end
    #resources :blogs
    resources :blogs do
      resources :blog_comments do
        member do
          post 'reply'
          get 'quote'
        end
      end
    end
  end
  resources :blog_comments do
    collection do
      get :search
    end
  end
  match 'users/:id/user_newfeedback', :to => 'users#user_newfeedback',  :via => :get, :as => "feedback"
  match 'users/:id/user_projects', :to => 'users#user_projects',  :via => :get
  #消息
  match 'users/:id/user_messages', :to => 'users#user_messages', :via => :get, :as => "user_message"
  match 'users/:id/user_system_messages', :to => 'users#user_system_messages', :via => :get, :as => "user_system_messages"
  match 'set_homepage', :to => 'blogs#set_homepage', :via => :post
  match 'cancel_homepage', :to => 'blogs#cancel_homepage', :via => :post
  #match 'users/:id/user_messages/:homework', :to => 'users#user_messages_homework', :via => :get, :as => "user_message_homewrok"



  #end
  match 'my/account',  :via => [:get, :post]
  match 'my/account/destroy', :to => 'my#destroy', :via => [:get, :post]
  match 'my/page',  :via => :get
  match 'my', :to => 'my#index', :via => :get # Redirects to my/page
  match 'my/reset_rss_key',  :via => :post
  match 'my/reset_api_key',  :via => :post
  match 'my/password',  :via => [:get, :post]
  match 'my/page_layout', :via => :get
  match 'my/add_block',  :via => :post
  match 'my/remove_block',  :via => :post
  match 'my/order_blocks',  :via => :post
  match 'my/change_mail_notification', via: :get
  match 'my/save_user_avatar', :to => 'my#save_user_avatar', :via => [:get, :post]
  match 'my/clear_user_avatar_temp', :to => 'my#clear_user_avatar_temp', :via => [:get, :post]

  get 'my/page2', :to => 'my#page2',  :as => "my_page2"

  resources :users
  match 'users/:id/memberships/:membership_id', :to => 'users#edit_membership', :via => :put, :as => 'user_membership'
  match 'users/:id/memberships/:membership_id', :to => 'users#destroy_membership', :via => :delete
  match 'users/:id/memberships', :to => 'users#edit_membership', :via => :post, :as => 'user_memberships'
  #################  added by william
  match 'users/tag_save', :via => :post, :as => 'tag'
  match 'users/tag_saveEx',  :via => [:get, :post]
  #get 'users/:id/user_organizations', :to => 'users#user_organizations', :as => 'user_organizations'
  post 'watchers/watch', :to => 'watchers#watch', :as => 'watch'
  delete 'watchers/watch', :to => 'watchers#unwatch'
  get 'watchers/new', :to => 'watchers#new'
  post 'watchers', :to => 'watchers#create'
  post 'watchers/append', :to => 'watchers#append'
  delete 'watchers', :to => 'watchers#destroy'
  get 'watchers/autocomplete_for_user', :to => 'watchers#autocomplete_for_user'
  # Specific routes for issue watchers API
  post 'issues/:object_id/watchers', :to => 'watchers#create', :object_type => 'issue'
  delete 'issues/:object_id/watchers/:user_id' => 'watchers#destroy', :object_type => 'issue'

  post 'appliedproject/applied', :to => 'applied_project#applied_join_project', :as => 'appliedproject'
  delete 'appliedproject/applied', :to => 'applied_project#unapplied_join_project'

  resources :projects do
    member do
      match 'change_project_type', :via =>  [:get, :post]
      get 'settings(/:tab)', :action => 'settings', :as => 'settings'
      #by young
      get 'member', :to => 'projects#member', :as => 'member'
      get 'file', :action => 'file', :as => 'file'
      get 'statistics', :action => 'statistics', :as => 'statistics'

      get 'feedback', :action => 'feedback', :as => 'project_feedback'
      get 'watcherlist', :action=> 'watcherlist'

      # get 'invite_members', :action=> 'invite_members'
      get 'invite_members_by_mail', :action=> 'invite_members_by_mail'
      # get 'dts_repos', :aciton => 'dts_repos'
      get 'send_mail_to_member', :action => 'send_mail_to_member'
      match 'user_watcherlist', :to => 'projects#watcherlist',  :via => :get, :as => "watcherlist"
      #end
      post 'modules'
      post 'archive'
      post 'unarchive'
      post 'close'
      post 'reopen'
      get 'search_public_orgs_not_in_project'
      match 'copy', :via => [:get, :post]
      match 'set_public_or_private', :via => [:post]
    end

    collection do
      match 'join_project', :via => [:get, :post]
    end

    #by young
    match '/member', :to => 'projects#member',  :as => 'member', :via => :get
    match '/file', :to => 'projects#file',  :as => 'file', :via => :get
    match '/statistics', :to => 'projects#statistics',  :as => 'statistics', :via => :get
    match '/watcherlist', :to=>'projects#watcherlist', :as => 'watcherlist', :via => :get  #add by huang

    resources :memberships, :shallow => true, :controller => 'members', :only => [:index, :show, :new, :create, :update, :destroy] do
      collection do
        get 'autocomplete'
        get 'appliedproject'
      end
    end

    resource :enumerations, :controller => 'project_enumerations', :only => [:update, :destroy]

    get 'issues/:copy_from/copy', :to => 'issues#new', :as => 'copy_issue'
    resources :issues, :only => [:index, :new, :create] do
      resources :time_entries, :controller => 'timelog' do
        collection do
          get 'report'
        end
      end
    end
    # issue form update
    match 'issues/update_form', :to => 'issues#update_form', :via => [:put, :post], :as => 'issue_form'

    resources :files, :only => [:index, :new, :create] do
      collection do
        match "getattachtype", :via =>  [:get, :post]
        match "search_project",:via => [:post,:get]
        match "searchone4reload",:via => [:post,:get]
        match "search_tag_attachment", :via => [:post,:get]
      end
      member do
        match "quote_resource_show", :via => [:get]
        get "file_hidden"
      end
    end

    # resources :files, :only => [:index, :new, :create] do
    #   member do
    #     match "quote_resource_show_project",:via => [:get]
    #   end
    #   collection do
    #     match "getattachtype" , :via =>  [:get, :post]
    #     match "search_project",:via => [:post,:get]
    #     #match 'getattachtype/:attachtype', :to => 'files#getattachtype', :via =>  [:get, :post]
    #   end
    # end


    resources :versions, :except => [:index, :show, :edit, :update, :destroy] do
      collection do
        put 'close_completed'
      end
    end
    get 'versions.:format', :to => 'versions#index'
    get 'roadmap', :to => 'versions#index', :format => false
    get 'versions', :to => 'versions#index'

    resources :news, :except => [:show, :edit, :update, :destroy]
    resources :time_entries, :controller => 'timelog' do
      get 'report', :on => :collection
    end
    resources :queries, :only => [:new, :create]
    resources :issue_categories, :shallow => true
    resources :documents, :except => [:show, :edit, :update, :destroy]
    resources :boards
    resources :repositories, :shallow => true, :except => [:index, :show] do
      member do
        match 'committers', :via => [:get, :post]
      end
    end
    resources :repositories, :except => [:index, :show] do
      member do
        get 'newrepo', :via => [:get, :post]
        put 'to_gitlab'
        # get 'create', :via=>[:get, :post]
      end
    end

    match 'wiki/index',  :via => :get
    resources :wiki, :except => [:index, :new, :create], :as => 'wiki_page' do
      member do
        get 'rename'
        post 'rename'
        get 'history'
        get 'diff'
        match 'preview', :via => [:post, :put]
        post 'protect'
        post 'add_attachment'
      end
      collection do
        get 'export'
        get 'date_index'
      end
    end
    match 'wiki', :to => 'wiki#show', :via => :get
    get 'wiki/:id/:version', :to => 'wiki#show', :constraints => {:version => /\d+/}
    delete 'wiki/:id/:version', :to => 'wiki#destroy_version'
    get 'wiki/:id/:version/annotate', :to => 'wiki#annotate'
    get 'wiki/:id/:version/diff', :to => 'wiki#diff'
  end

  resources :issues do
    collection do
      match 'bulk_edit', :via => [:get, :post]
      post 'bulk_update'
    end
    member do
      post 'add_journal'
      post 'add_journal_in_org'
      get 'delete_journal'
      get 'reply'
      post 'add_reply'
    end
    resources :time_entries, :controller => 'timelog' do
      collection do
        get 'report'
      end
    end
    resources :relations, :shallow => true, :controller => 'issue_relations', :only => [:index, :show, :create, :destroy]
  end
  match '/issues', :to => 'issues#destroy', :via => :delete

  resources :queries, :except => [:show]

  resources :news, :only => [:index, :show, :edit, :update, :destroy]
  match '/news/:id/comments', :to => 'comments#create', :via => :post
  #match '/news/:id/comments/:comment_id', :to => 'comments#destroy', :via => :delete
  delete '/news/:id/comments/:comment_id', :to => 'comments#destroy', as: :delete_news_comments

  resources :versions, :only => [:show, :edit, :update, :destroy] do
    post 'status_by', :on => :member
  end

  resources :documents, :only => [:show, :edit, :update, :destroy] do
    post 'add_attachment', :on => :member
  end

  match '/time_entries/context_menu', :to => 'context_menus#time_entries', :as => :time_entries_context_menu, :via => [:get, :post]

  resources :time_entries, :controller => 'timelog', :except => :destroy do
    collection do
      get 'report'
      get 'bulk_edit'
      post 'bulk_update'
    end
  end
  match '/time_entries/:id', :to => 'timelog#destroy', :via => :delete, :id => /\d+/
  # TODO: delete /time_entries for bulk deletion
  match '/time_entries/destroy', :to => 'timelog#destroy', :via => :delete

  get 'projects/:id/activity', :to => 'activities#index'
  get 'projects/:id/activity.:format', :to => 'activities#index'
  get 'activity', :to => 'activities#index'

  # repositories routes
  get 'projects/:id/repository/:repository_id/statistics', :to => 'repositories#stats', :as => "stats_repository_project"
  get 'projects/:id/repository/:repository_id/graph', :to => 'repositories#graph'

  get 'projects/:id/repository/:repository_id/changes(/*path(.:ext))', :to => 'repositories#changes'

  get 'projects/:id/repository/:repository_id/revisions/:rev', :to => 'repositories#revision'
  get 'projects/:id/repository/:repository_id/revision', :to => 'repositories#revision'
  post   'projects/:id/repository/:repository_id/revisions/:rev/issues', :to => 'repositories#add_related_issue'
  delete 'projects/:id/repository/:repository_id/revisions/:rev/issues/:issue_id', :to => 'repositories#remove_related_issue'
  get 'projects/:id/repository/:repository_id/revisions', :to => 'repositories#revisions'
  get 'projects/:id/repository/:repository_id/revisions/:rev/:action(/*path(.:ext))',
      :controller => 'repositories',
      :format => false,
      :constraints => {
          :action => /(browse|show|entry|raw|annotate|diff|commit_diff)/,
          :rev    => /[a-z0-9\.\-_]+/
      }

  get 'projects/:id/repository/statistics', :to => 'repositories#stats'
  get 'projects/:id/repository/graph', :to => 'repositories#graph'

  get 'projects/:id/repository/changes(/*path(.:ext))', :to => 'repositories#changes'

  get 'projects/:id/repository/forked', :to => 'repositories#forked'
  get 'projects/:id/repository/project_archive', :to => 'repositories#project_archive', :as => 'project_archive'
  get 'projects/:id/repository/revisions', :to => 'repositories#revisions'
  get 'projects/:id/repository/revisions/:rev', :to => 'repositories#revision'
  get 'projects/:id/repository/revision', :to => 'repositories#revision'
  post   'projects/:id/repository/revisions/:rev/issues', :to => 'repositories#add_related_issue'
  delete 'projects/:id/repository/revisions/:rev/issues/:issue_id', :to => 'repositories#remove_related_issue'
  get 'projects/:id/repository/revisions/:rev/:action(/*path(.:ext))',
      :controller => 'repositories',
      :format => false,
      :constraints => {
          :action => /(browse|show|entry|raw|annotate|diff|commit_diff)/,
          :rev    => /[a-z0-9\.\-_]+/
      }
  get 'projects/:id/repository/:repository_id/:action(/*path(.:ext))',
      :controller => 'repositories',
      :action => /(browse|show|entry|raw|changes|annotate|diff|commit_diff)/
  get 'projects/:id/repository/:action(/*path(.:ext))',
      :controller => 'repositories',
      :action => /(browse|show|entry|raw|changes|annotate|diff|commit_diff)/

  get 'projects/:id/repository/:repository_id', :to => 'repositories#show', :path => nil
  get 'projects/:id/repository', :to => 'repositories#show', :path => nil
  get 'projects/:id/exit', :to => 'projects#exit_project', :as => 'exit_cur_project'

  # additional routes for having the file name at the end of url
  get 'attachments/:id/:filename', :to => 'attachments#show', :id => /\d+/, :filename => /.*/, :as => 'named_attachment'
  get 'attachments/attachment_versions/:id',:to=>'attachments#attachment_versions',:as=>'attachments_versions'
  get 'attachments/attachment_history_download/:id',:to=>'attachments#attachment_history_download',:as=>'attachment_history_download'
  post 'attachments/upload_attachment_version',:to=>'attachments#upload_attachment_version',:as=>'upload_attachment_version'
  get 'attachments/download/:id/:filename', :to => 'attachments#download', :id => /\d+/, :filename => /.*/, :as => 'download_named_attachment'
  get 'attachments/download_history/:id/:filename', :to => 'attachments#download_history', :id => /\d+/, :filename => /.*/, :as => 'download_history_attachment'
  get 'attachments/download/:id', :to => 'attachments#download', :id => /\d+/
  get 'attachments/thumbnail/:id(/:size)', :to => 'attachments#thumbnail', :id => /\d+/, :size => /\d+/, :as => 'thumbnail'
  get 'attachments/autocomplete'
  match 'attachments/autocomplete', :to => 'attachments#autocomplete', :via =>  [:post]
  post 'attachments/relationfile', to: 'attachments#add_exist_file_to_project', as: 'attach_relation'
  post 'attachments/relationfiles', to: 'attachments#add_exist_file_to_projects', as: 'attach_relations'
  post 'attachments/courserelationfile', to: 'attachments#add_exist_file_to_course', as: 'course_attach_relation'
  post 'attachments/courserelationfiles', to: 'attachments#add_exist_file_to_courses', as: 'course_attach_relations'
  match 'attachments/add_exist_file_to_org_subfield'
  get  'attachments/renderTag/:attchmentId', :to => 'attachments#renderTag', :attchmentId => /\d+/
  resources :attachments, :only => [:show, :destroy]  do
    collection do
      match "updateType" , :via =>  [:get, :post]
      match "updateFileDense" , :via =>  [:get, :post]
      match "update_file_dense", :via => [:post]
      match "renderTag" , :via =>  [:get, :post]
      match 'delete_softapplications', :via =>  [:get, :post]
    end
  end

  resources :groups do
    member do
      get 'autocomplete_for_user'
    end
  end

  match 'groups/:id/users', :to => 'groups#add_users', :id => /\d+/, :via => :post, :as => 'group_users'
  match 'groups/:id/users/:user_id', :to => 'groups#remove_user', :id => /\d+/, :via => :delete, :as => 'group_user'
  match 'groups/destroy_membership/:id', :to => 'groups#destroy_membership', :id => /\d+/, :via => :post
  match 'groups/edit_membership/:id', :to => 'groups#edit_membership', :id => /\d+/, :via => :post

  resources :trackers, :except => :show do
    collection do
      match 'fields', :via => [:get, :post]
    end
  end
  resources :issue_statuses, :except => :show do
    collection do
      post 'update_issue_done_ratio'
    end
  end
  resources :custom_fields, :except => :show
  resources :roles do
    collection do
      match 'permissions', :via => [:get, :post]
    end
  end
  resources :web_footer_companies, :except => :show
  resources :enumerations, :except => :show
  match 'enumerations/:type', :to => 'enumerations#index', :via => :get

  get 'projects/:id/search', :controller => 'search', :action => 'index'
  get 'search', :controller => 'search', :action => 'index'

  match 'mail_handler', :to => 'mail_handler#index', :via => :post
  match 'mail_handler/cancel/:id', :to => 'mail_handler#cancel_mail_notify',:via => :get

  match 'admin', :to => 'admin#index', :via => :get
  match 'admin/projects',  :via => :get
  get 'admin/courses'
  get 'admin/excellent_courses', as: :excellent_courses
  get 'admin/excellent_all_courses', as: :excellent_all_courses
  match 'admin/set_excellent_course/:id', :to => 'admin#set_excellent_course'
  get 'admin/course_resource_list'
  get 'admin/project_resource_list'
  match 'admin/users',  :via => :get
  match 'admin/messages',  :via => :get
  match 'admin/first_page_made', as: :first_page_made
  match 'admin/course_page_made', as: :course_page_made
  match 'admin/contest_page_made', as: :contest_page_made
  match 'admin/web_footer_made', as: :web_footer_made
  match 'admin/enterprise_page_made', as: :enterprise_page_made
  match 'admin/mobile_version', as: :mobile_version
  match 'admin/create_version', as: :create_version
  match 'admin/search',  :via => [:get, :post]
  match 'admin/plugins',  :via => :get
  match 'admin/info',  :via => :get
  match 'admin/test_email',  :via => :get
  match 'admin/default_configuration', :via => :post
  get 'admin/organization'
  get 'admin/schools'
  get 'admin/leave_messages'
  match 'admin/messages_list', as: :messages_list
  match 'admin/project_messages', as: :project_messages
  match'admin/course_messages', as: :course_messages
  get 'admin/notices'
  match 'admin/latest_login_users', as: :latest_login_users
  match 'admin/latest_login_teachers', as: :latest_login_teachers
  get 'admin/homework'
  get 'admin/apply_for_homework'
  get 'admin/code_work_tests'

  resources :auth_sources do
    member do
      get 'test_connection', :as => 'try_connection'
    end
    collection do
      get 'autocomplete_for_new_user'
    end
  end

  match 'courses/search'
  match '/contests/search', :via => [:get, :post]
  # add by nwb
  # 课程路由设置
  resources :courses do
    member do
      get 'settings(/:tab)', :action => 'settings', :as => 'settings'
      get 'search_member', :action => 'search_member'
      get 'file', :action => 'file', :as => 'file'
      get 'feedback', :action => 'feedback', :as => 'course_feedback'
      get 'code_repeat', :action => 'code_repeat', :as => 'code_repeat'
      get 'member', :controller => 'courses', :action => 'member', :as => 'member'
      get 'export_course_member_excel',:controller => 'courses',:action => 'export_course_member_excel'
      get 'member_score', :to => 'courses#member_score'
      post 'finishcourse'
      post 'restartcourse'
      match "renew", :to => 'courses#renew', :via => [:post, :get], :as =>'renew'
      match "searchmembers", :controller => 'courses', :action => 'searchmembers', :via => [:post,:get]
      match "searchgroupmembers", :via => [:post, :get]
      match 'member_score_sort', :via => [:get]
      match "updategroupname", :via => [:post, :get]
      match "addgroups",  :via => [:post, :get]
      match 'deletegroup', :via => [:delete]
      match 'show_member_score', :via => [:get]
      match 'show_member_act_score', :via => [:get]
      match 'valid_ajax', :to => 'courses#valid_ajax', :via => :get
      post 'join_in/join_group', :to => 'courses#join_group', :as => 'join_group'
      delete 'join_in/join_group', :to => 'courses#unjoin_group'
      get 'copy_course'
      get 'private_or_public'
      match 'course_activity', :to => 'courses#course_activity',  :via => :get, :as => "course_activity"
      get 'course_outline'
      post 'search_course_outline'
      post 'set_course_outline'
      post 'teacher_assign_group'
      get 'syllabus'
      get 'search_public_orgs_not_in_course'
      get "homework_search"
      get "show_comparecode"
    end
    collection do
      match 'join_private_courses', :via => [:get, :post]
    end

    match '/member', :to => 'courses#member',  :as => 'member', :via => :get
    resources :boards
    resources :files, :only => [:index, :new, :create] do
      collection do
        match "getattachtype", :via =>  [:get, :post]
        match "search",:via => [:post,:get]
        match "searchone4reload",:via => [:post,:get]
        match "search_tag_attachment", :via => [:post,:get]
      end
      member do
        match "quote_resource_show", :via => [:get]
        get "file_hidden"
        post "republish_file"
      end
    end
    resources :memberships, :shallow => true, :controller => 'members', :only => [:index, :show, :new, :create, :update, :destroy] do
      collection do
        get 'autocomplete'
        get 'appliedproject'
      end
    end
    resources :news, :except => [:show, :edit, :update, :destroy]
    # resources :boards do
    #   member do
    #     match 'boards_topic', :to => 'boards#boards_topic',  :via => :get, :as => "boards_topic"
    #   end
    # end
    match '/homework', :to => 'courses#homework', :as => 'homework', :via => :get
    resources :activity_notifys do
      collection do
        match 'chang_read_flag', :via => :get
      end
    end

  end   # end of resources :courses
  match 'courses/:id/feedback', :to => 'courses#feedback',  :via => :get, :as => 'course_feedback'
  match '/courses/search',  :via => [:get, :post]
  match 'words/:id/leave_course_message', :to => 'words#leave_course_message'


  match 'workflows', :to => 'workflows#index', :via => :get
  match 'workflows/edit',  :via => [:get, :post]
  match 'workflows/permissions',  :via => [:get, :post]
  match 'workflows/copy',  :via => [:get, :post]
  match 'settings', :controller => 'settings', :action => 'index', :via => :get
  match 'settings/edit',  :via => [:get, :post]
  match 'settings/plugin/:id', :to => 'settings#plugin', :via => [:get, :post], :as => 'plugin_settings'
  match 'settings/hidden_non_project', :via => [:get, :post]
  match 'settings/hidden_courses', :via => [:get, :post]

  match 'sys/projects',  :via => :get
  match 'sys/projects/:id/repository', :to => 'sys#create_project_repository', :via => :post
  match 'sys/fetch_changesets', :via => :get

  match 'uploads', :to => 'attachments#upload', :via => :post
  # Added by Tao
  match 'upload_avatar', :to => 'avatar#upload', :via => :post
  match 'delete_avatar', :to => 'avatar#delete_image',:via => :post
  # Endof Tao's code
  get 'robots.txt', :to => 'welcome#robots'
  ##############测试留言功能    fq
  post 'words/new', :to => 'words#new'
  post 'words/create', :to => 'words#create'
  post 'words/append', :to => 'words#append'
  post 'words/create_reply', :to => 'words#create_reply'
  delete 'words/destroy', :to => 'words#destroy'
  delete 'words/destroyJournal', :to => 'words#destroyJournal'
  get 'words/more', :to => 'words#more'
  get 'words/back', :to=> 'words#back'
  get 'words/destroyJournal', :to => 'words#destroyJournal'
  match 'words/add_project_respond', :to => 'words#add_project_respond'
  match 'words/:id/leave_project_message', :to => 'words#leave_project_message'
  match 'projects/:id/feedback', :to => 'projects#feedback',  :via => :get, :as => 'project_feedback'
  match 'project/:id/share', :to => 'projects#share', :as => 'share_show' #share
  post 'words/:id/leave_user_message', :to => 'words#leave_user_message', :as => "leave_user_message"
  post 'words/:id/leave_homework_message', :to => 'words#leave_homework_message', :as => "leave_homework_message"
  post 'words/:id/reply_to_homework', :to => 'words#reply_to_homework', :as => "reply_to_homework"

  post 'join_in/join', :to => 'courses#join', :as => 'join'
  delete 'join_in/join', :to => 'courses#unjoin'
  post 'join_in/join_group', :to => 'courses#join_group', :as => 'join_group'
  delete 'join_in/join_group', :to => 'courses#unjoin_group'

  delete 'attachment/:id', :to => 'attachments#delete_homework'
  match 'new_join', :to => 'courses#new_join', :as => 'try_join'
  match 'new_join_group', :to => 'courses#new_join_group', :as => 'try_join_group'
  match 'projects/:id/respond', :to => 'projects#project_respond', :via => :post

  ########################
  ##added by wen##########
  #######confusing########
  get 'welcome/search', to: 'welcome#search'
  get 'school/index', to: 'school#index'
  get 'school/:school_id', to: 'welcome#course', :as => 'school_course_list'
  post 'school/get_options/:province', :to => 'school#get_options'
  get 'school/get_options/:province', :to => 'school#get_options'

  post 'school/get_province', :to => 'school#get_province'
  get 'school/get_province', :to => 'school#get_province'

  post 'school/get_schoollist/:province', :to => 'school#get_schoollist'
  get 'school/get_schoollist/:province', :to => 'school#get_schoollist'

  post 'school/search_school/', :to => 'school#search_school'
  get 'school/search_school/', :to => 'school#search_school'

  post 'school/on_search'
  post 'school/add_school'
  ######added by nie
  match 'tags/show_projects_tags'
  ########### added by liuping
  match 'tags/add_tag', :as=>"add_tag"
  match 'tags/delete_tag', :as=>"add_tag"
  match 'tags/show_all'
  match 'parise_tread/praise_plus', :as=>"praise"
  match 'parise_tread/tread_plus', :as=>"tread"
  match 'tags/delete'
  match 'tags/remove_tag', :as=>"remove_tag"
  match 'tags/remove_tag_new', :as=>"remove_tag_new"
  match 'tags/tag_save', :as => "save_tag"
  match 'tags/update_tag_name',:as => "update_tag_name"
  match 'tags/update_project_tag_name',:as => "update_project_tag_name"
  match 'tags/update_org_subfield_tag_name'

  match 'words/add_brief_introdution'

  ##added by lizanle 日志查看路由
  match 'system_log/index'
  match 'system_log/access_analysis'
  match 'system_log/time_analysis'
  match "/system_log" ,:to => 'system_log#index'
  match 'system_log/clear'
  get 'upload_files_menu', :to => 'files#upload_files_menu'
  get '/manual/feedback', to:redirect("http://forge.trustie.net/forums/1/memos/1168")
  ##ended by lizanle

  resources :git_callback do
    collection do
      post 'post_update'
    end
  end

  resources :at
  resource :wechat, only:[:show, :create] do
    collection do
      get :login
      get :user_activities
      post :bind
      post :get_open_id
    end
  end

  resource :sso, only: [:show, :create]

  get '/:sub_dir_name', :to => 'org_subfields#show', :as => 'show_subfield_without_id'

  Dir.glob File.expand_path("plugins/*", Rails.root) do |plugin_dir|
    file = File.join(plugin_dir, "config/routes.rb")
    if File.exists?(file)
      begin
        instance_eval File.read(file)
      rescue Exception => e
        puts "An error occurred while loading the routes definition of #{File.basename(plugin_dir)} plugin (#{file}): #{e.message}."
        exit 1
      end
    end
  end
end
